Open CASCADE Technology: Adaptor3d_Curve Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
Adaptor3d_Curve Class Reference

Root class for 3D curves on which geometric algorithms work. An adapted curve is an interface between the services provided by a curve and those required of the curve by algorithms which use it. Two derived concrete classes are provided: More...

`#include <Adaptor3d_Curve.hxx>`

Inheritance diagram for Adaptor3d_Curve:
[legend]

## Public Member Functions
virtual Standard_Real | FirstParameter () const
virtual Standard_Real | LastParameter () const
virtual GeomAbs_Shape | Continuity () const
virtual Standard_Integer | NbIntervals (const GeomAbs_Shape S) const
| Returns the number of intervals for continuity <S>. May be one if Continuity(me) >= <S> More...
virtual void | Intervals (TColStd_Array1OfReal &T, const GeomAbs_Shape S) const
| Stores in <T> the parameters bounding the intervals of continuity <S>. More...
virtual Handle< Adaptor3d_HCurve > | Trim (const Standard_Real First, const Standard_Real Last, const Standard_Real Tol) const
| Returns a curve equivalent of <me> between parameters <First> and <Last>. <Tol> is used to test for 3d points confusion. If <First> >= <Last> More...
virtual Standard_Boolean | IsClosed () const
virtual Standard_Boolean | IsPeriodic () const
virtual Standard_Real | Period () const
virtual gp_Pnt | Value (const Standard_Real U) const
| Computes the point of parameter U on the curve. More...
virtual void | D0 (const Standard_Real U, gp_Pnt &P) const
| Computes the point of parameter U on the curve. More...
virtual void | D1 (const Standard_Real U, gp_Pnt &P, gp_Vec &V) const
| Computes the point of parameter U on the curve with its first derivative. Raised if the continuity of the current interval is not C1. More...
virtual void | D2 (const Standard_Real U, gp_Pnt &P, gp_Vec &V1, gp_Vec &V2) const
| Returns the point P of parameter U, the first and second derivatives V1 and V2. Raised if the continuity of the current interval is not C2. More...
virtual void | D3 (const Standard_Real U, gp_Pnt &P, gp_Vec &V1, gp_Vec &V2, gp_Vec &V3) const
| Returns the point P of parameter U, the first, the second and the third derivative. Raised if the continuity of the current interval is not C3. More...
virtual gp_Vec | DN (const Standard_Real U, const Standard_Integer N) const
| The returned vector gives the value of the derivative for the order of derivation N. Raised if the continuity of the current interval is not CN. Raised if N < 1. More...
virtual Standard_Real | Resolution (const Standard_Real R3d) const
| Returns the parametric resolution corresponding to the real space resolution <R3d>. More...
virtual GeomAbs_CurveType | GetType () const
| Returns the type of the curve in the current interval : Line, Circle, Ellipse, Hyperbola, Parabola, BezierCurve, BSplineCurve, OtherCurve. More...
virtual gp_Lin | Line () const
virtual gp_Circ | Circle () const
virtual gp_Elips | Ellipse () const
virtual gp_Hypr | Hyperbola () const
virtual gp_Parab | Parabola () const
virtual Standard_Integer | Degree () const
virtual Standard_Boolean | IsRational () const
virtual Standard_Integer | NbPoles () const
virtual Standard_Integer | NbKnots () const
virtual Handle< Geom_BezierCurve > | Bezier () const
virtual Handle< Geom_BSplineCurve > | BSpline () const
virtual | ~Adaptor3d_Curve ()

## Detailed Description

Root class for 3D curves on which geometric algorithms work. An adapted curve is an interface between the services provided by a curve and those required of the curve by algorithms which use it. Two derived concrete classes are provided:

- GeomAdaptor_Curve for a curve from the Geom package
- Adaptor3d_CurveOnSurface for a curve lying on a surface from the Geom package.

## Constructor & Destructor Documentation

virtual Adaptor3d_Curve::~Adaptor3d_Curve | ( |  | ) |
| virtual

## Member Function Documentation

virtual Handle< Geom_BezierCurve > Adaptor3d_Curve::Bezier | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, GeomAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, and ChFiDS_ElSpine.

virtual Handle< Geom_BSplineCurve > Adaptor3d_Curve::BSpline | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, GeomAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, and ChFiDS_ElSpine.

virtual gp_Circ Adaptor3d_Curve::Circle | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, GeomAdaptor_Curve, ChFiDS_ElSpine, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual GeomAbs_Shape Adaptor3d_Curve::Continuity | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, ChFiDS_ElSpine, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual void Adaptor3d_Curve::D0 | ( | const Standard_Real | U,
|  | gp_Pnt & | P
| ) |  | const
| virtual

Computes the point of parameter U on the curve.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, ChFiDS_ElSpine, and GeomFill_SnglrFunc.

virtual void Adaptor3d_Curve::D1 | ( | const Standard_Real | U,
|  | gp_Pnt & | P,
|  | gp_Vec & | V
| ) |  | const
| virtual

Computes the point of parameter U on the curve with its first derivative. Raised if the continuity of the current interval is not C1.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, ChFiDS_ElSpine, and GeomFill_SnglrFunc.

virtual void Adaptor3d_Curve::D2 | ( | const Standard_Real | U,
|  | gp_Pnt & | P,
|  | gp_Vec & | V1,
|  | gp_Vec & | V2
| ) |  | const
| virtual

Returns the point P of parameter U, the first and second derivatives V1 and V2. Raised if the continuity of the current interval is not C2.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, ChFiDS_ElSpine, and GeomFill_SnglrFunc.

virtual void Adaptor3d_Curve::D3 | ( | const Standard_Real | U,
|  | gp_Pnt & | P,
|  | gp_Vec & | V1,
|  | gp_Vec & | V2,
|  | gp_Vec & | V3
| ) |  | const
| virtual

Returns the point P of parameter U, the first, the second and the third derivative. Raised if the continuity of the current interval is not C3.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, ChFiDS_ElSpine, and GeomFill_SnglrFunc.

virtual Standard_Integer Adaptor3d_Curve::Degree | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BRepAdaptor_CompCurve, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual gp_Vec Adaptor3d_Curve::DN | ( | const Standard_Real | U,
|  | const Standard_Integer | N
| ) |  | const
| virtual

The returned vector gives the value of the derivative for the order of derivation N. Raised if the continuity of the current interval is not CN. Raised if N < 1.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, and GeomFill_SnglrFunc.

virtual gp_Elips Adaptor3d_Curve::Ellipse | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, GeomAdaptor_Curve, ChFiDS_ElSpine, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual Standard_Real Adaptor3d_Curve::FirstParameter | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, ChFiDS_ElSpine, BiTgte_CurveOnVertex, and GeomFill_SnglrFunc.

virtual GeomAbs_CurveType Adaptor3d_Curve::GetType | ( |  | ) | const
| virtual

Returns the type of the curve in the current interval : Line, Circle, Ellipse, Hyperbola, Parabola, BezierCurve, BSplineCurve, OtherCurve.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, GeomFill_SnglrFunc, and ChFiDS_ElSpine.

virtual gp_Hypr Adaptor3d_Curve::Hyperbola | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, GeomAdaptor_Curve, ChFiDS_ElSpine, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual void Adaptor3d_Curve::Intervals | ( | TColStd_Array1OfReal & | T,
|  | const GeomAbs_Shape | S
| ) |  | const
| virtual

Stores in <T> the parameters bounding the intervals of continuity <S>.

The array must provide enough room to accomodate for the parameters. i.e. T.Length() > NbIntervals()

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, ChFiDS_ElSpine, and GeomFill_SnglrFunc.

virtual Standard_Boolean Adaptor3d_Curve::IsClosed | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual Standard_Boolean Adaptor3d_Curve::IsPeriodic | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, ChFiDS_ElSpine, and GeomFill_SnglrFunc.

virtual Standard_Boolean Adaptor3d_Curve::IsRational | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, GeomAdaptor_Curve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual Standard_Real Adaptor3d_Curve::LastParameter | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, ChFiDS_ElSpine, BiTgte_CurveOnVertex, and GeomFill_SnglrFunc.

virtual gp_Lin Adaptor3d_Curve::Line | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, GeomAdaptor_Curve, ChFiDS_ElSpine, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual Standard_Integer Adaptor3d_Curve::NbIntervals | ( | const GeomAbs_Shape | S | ) | const
| virtual

Returns the number of intervals for continuity <S>. May be one if Continuity(me) >= <S>

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, ChFiDS_ElSpine, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, and GeomFill_SnglrFunc.

virtual Standard_Integer Adaptor3d_Curve::NbKnots | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, GeomAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual Standard_Integer Adaptor3d_Curve::NbPoles | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, GeomAdaptor_Curve, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual gp_Parab Adaptor3d_Curve::Parabola | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, GeomAdaptor_Curve, ChFiDS_ElSpine, BiTgte_CurveOnEdge, and BiTgte_CurveOnVertex.

virtual Standard_Real Adaptor3d_Curve::Period | ( |  | ) | const
| virtual

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, ChFiDS_ElSpine, BiTgte_CurveOnVertex, and GeomFill_SnglrFunc.

virtual Standard_Real Adaptor3d_Curve::Resolution | ( | const Standard_Real | R3d | ) | const
| virtual

Returns the parametric resolution corresponding to the real space resolution <R3d>.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, Adaptor3d_CurveOnSurface, BRepAdaptor_CompCurve, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, GeomFill_SnglrFunc, and ChFiDS_ElSpine.

virtual Handle< Adaptor3d_HCurve > Adaptor3d_Curve::Trim | ( | const Standard_Real | First,
|  | const Standard_Real | Last,
|  | const Standard_Real | Tol
| ) |  | const
| virtual

Returns a curve equivalent of <me> between parameters <First> and <Last>. <Tol> is used to test for 3d points confusion. If <First> >= <Last>

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, BiTgte_CurveOnVertex, and ChFiDS_ElSpine.

virtual gp_Pnt Adaptor3d_Curve::Value | ( | const Standard_Real | U | ) | const
| virtual

Computes the point of parameter U on the curve.

Reimplemented in BRepAdaptor_Curve, ProjLib_ProjectOnPlane, Adaptor3d_IsoCurve, BRepAdaptor_CompCurve, Adaptor3d_CurveOnSurface, GeomAdaptor_Curve, BiTgte_CurveOnEdge, ChFiDS_ElSpine, BiTgte_CurveOnVertex, and GeomFill_SnglrFunc.

The documentation for this class was generated from the following file:

- Adaptor3d_Curve.hxx